<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-comms](./foundation-comms.md) &gt; [Datasource](./foundation-comms.datasource.md)

## Datasource interface

Datasource interface.

**Signature:**

```typescript
export interface Datasource extends DatasourceMetadata 
```
**Extends:** [DatasourceMetadata](./foundation-comms.datasourcemetadata.md)

## Remarks

The public interface available on the injected store fragment.

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [initialized](./foundation-comms.datasource.initialized.md) |  | boolean | Indicates whether the datasource has been initialized. |
|  [readOnly](./foundation-comms.datasource.readonly.md) |  | boolean | Indicates whether the datasource is read-only. TODO: Should have is prefix |
|  [resourceType](./foundation-comms.datasource.resourcetype.md) |  | [ResourceType](./foundation-comms.resourcetype.md) | The type of resource the datasource represents. |
|  [status](./foundation-comms.datasource.status.md) |  | Partial&lt;[DatasourceStatus](./foundation-comms.datasourcestatus.md)<!-- -->&gt; |  |
|  [stream](./foundation-comms.datasource.stream.md) |  | [SocketObservable](./foundation-comms.socketobservable.md)<!-- -->&lt;[FilteredDataServerResult](./foundation-comms.filtereddataserverresult.md) \| [RequestServerResult](./foundation-comms.requestserverresult.md)<!-- -->&gt; | A stream of data from the datasource. |

## Methods

|  Method | Description |
|  --- | --- |
|  [addView(view)?](./foundation-comms.datasource.addview.md) | _(Optional)_ Adds the specified dataview to the datasource. |
|  [clearFilter(name)?](./foundation-comms.datasource.clearfilter.md) | _(Optional)_ Clears the filter with the specified name from the datasource. |
|  [createItem(data)?](./foundation-comms.datasource.createitem.md) | _(Optional)_ Creates a new item in the datasource with the specified data. |
|  [dataHandler(data)?](./foundation-comms.datasource.datahandler.md) | _(Optional)_ Handles the specified data and returns it. |
|  [deinit()](./foundation-comms.datasource.deinit.md) | Deinitializes the datasource. |
|  [deleteItem(itemId)?](./foundation-comms.datasource.deleteitem.md) | _(Optional)_ Deletes an item with the given ID from the datasource. |
|  [destroy()](./foundation-comms.datasource.destroy.md) | Destroy the datasource. |
|  [dropView(view)?](./foundation-comms.datasource.dropview.md) | _(Optional)_ Removes the specified dataview from the datasource. |
|  [getMetadata(resourceName)?](./foundation-comms.datasource.getmetadata.md) | _(Optional)_ Fetches metadata for the specified resource name. |
|  [init(options, fetchMeta)](./foundation-comms.datasource.init.md) | Initializes the datasource with the given options and fetches metadata if specified. |
|  [setFilter(name, value, type)?](./foundation-comms.datasource.setfilter.md) | _(Optional)_ Sets a filter on the datasource with the specified name, value, and type. |
|  [snapshot(params)](./foundation-comms.datasource.snapshot.md) | Takes a snapshot of the data in the datasource. |
|  [snapshotFiltered(rowId)](./foundation-comms.datasource.snapshotfiltered.md) | Takes a filtered snapshot of the data in the datasource. |
|  [updateData(data)?](./foundation-comms.datasource.updatedata.md) | _(Optional)_ Updates the data in the datasource with the specified data. |
|  [updateItem(itemId, data)?](./foundation-comms.datasource.updateitem.md) | _(Optional)_ Updates an item in the datasource with the given ID and data. |
|  [validResourceName(resourceName)](./foundation-comms.datasource.validresourcename.md) | Indicates whether the resourceName is valid or not. |

